# model: {{ model.getId() }}
Autogenerated ODE System from SBML with [sbmlutils](https://github.com/matthiaskoenig/sbmlutils).
```
time: [{{model_units["time"]}}]
substance: [{{model_units["substance"]}}]
extent: [{{model_units["extent"]}}]
volume: [{{model_units["volume"]}}]
area: [{{model_units["area"]}}]
length: [{{model_units["length"]}}]
```

## Parameters `p`
```
{% for id in pids %}
{{ id }} = {{p[id]}}  # [{{units[id]}}] {{names[id]}}  
{% endfor %}
```

## Initial conditions `x0`
```
{% for id in xids %}
{{ id }} = {{x0[id]}}  # [{{units[id]}}] {{names[id]}}{% if x_compartments[id] %} in {{x_compartments[id]}}{% endif %}  
{% endfor %}
```

## ODE system
```
# y
{% for id in yids %}
{{id}} = {{y[id]}}  # [{{units[id]}}] {{names[id]}}  
{% endfor %}

# odes
{% for id in xids %}
d {{ id }}/dt = {{dx[id]}}  # [{{units[id]}}/{{units["time"]}}] {{names[id]}}  
{% endfor %}
```
