# ---------------------------------------------------------------------------------------------------------
# Autogenerated ODE definition from SBML file with sbmlutils (https://github.com/matthiaskoenig/sbmlutils).
#
#    model: linear_chain
# ---------------------------------------------------------------------------------------------------------

# -------------------
# ids
# -------------------
xids <- c("S1", "S10", "S11", "S12", "S13", "S14", "S15", "S16", "S17", "S18", "S19", "S2", "S20", "S21", "S3", "S4", "S5", "S6", "S7", "S8", "S9")
pids <- c("cell", "k1", "k10", "k11", "k12", "k13", "k14", "k15", "k16", "k17", "k18", "k19", "k2", "k20", "k3", "k4", "k5", "k6", "k7", "k8", "k9")
yids <- c("J1", "J10", "J11", "J12", "J13", "J14", "J15", "J16", "J17", "J18", "J19", "J2", "J20", "J3", "J4", "J5", "J6", "J7", "J8", "J9")

# -------------------
# initial conditions
# -------------------
x0 = c(
  S1 = 10.0,      # [1]
  S10 = 0.0,      # [2]
  S11 = 0.0,      # [3]
  S12 = 0.0,      # [4]
  S13 = 0.0,      # [5]
  S14 = 0.0,      # [6]
  S15 = 0.0,      # [7]
  S16 = 0.0,      # [8]
  S17 = 0.0,      # [9]
  S18 = 0.0,      # [10]
  S19 = 0.0,      # [11]
  S2 = 0.0,      # [12]
  S20 = 0.0,      # [13]
  S21 = 0.0,      # [14]
  S3 = 0.0,      # [15]
  S4 = 0.0,      # [16]
  S5 = 0.0,      # [17]
  S6 = 0.0,      # [18]
  S7 = 0.0,      # [19]
  S8 = 0.0,      # [20]
  S9 = 0.0      # [21]
)

# -------------------
# parameters
# -------------------
p = c(
  cell = 1.0,      # [1]
  k1 = 0.1,      # [2]
  k10 = 0.1,      # [3]
  k11 = 0.1,      # [4]
  k12 = 0.1,      # [5]
  k13 = 0.1,      # [6]
  k14 = 0.1,      # [7]
  k15 = 0.1,      # [8]
  k16 = 0.1,      # [9]
  k17 = 0.1,      # [10]
  k18 = 0.1,      # [11]
  k19 = 0.1,      # [12]
  k2 = 0.1,      # [13]
  k20 = 0.1,      # [14]
  k3 = 0.1,      # [15]
  k4 = 0.1,      # [16]
  k5 = 0.1,      # [17]
  k6 = 0.1,      # [18]
  k7 = 0.1,      # [19]
  k8 = 0.1,      # [20]
  k9 = 0.1      # [21]
)


# -------------------
# dmod odes
# -------------------
dxdt_dmod <- c(
    S1 = "-(k1 * S1) / cell",   # [1]
    S10 = "k9 * S9 / cell - k10 * S10 / cell",   # [2]
    S11 = "k10 * S10 / cell - k11 * S11 / cell",   # [3]
    S12 = "k11 * S11 / cell - k12 * S12 / cell",   # [4]
    S13 = "k12 * S12 / cell - k13 * S13 / cell",   # [5]
    S14 = "k13 * S13 / cell - k14 * S14 / cell",   # [6]
    S15 = "k14 * S14 / cell - k15 * S15 / cell",   # [7]
    S16 = "k15 * S15 / cell - k16 * S16 / cell",   # [8]
    S17 = "k16 * S16 / cell - k17 * S17 / cell",   # [9]
    S18 = "k17 * S17 / cell - k18 * S18 / cell",   # [10]
    S19 = "k18 * S18 / cell - k19 * S19 / cell",   # [11]
    S2 = "k1 * S1 / cell - k2 * S2 / cell",   # [12]
    S20 = "k19 * S19 / cell - k20 * S20 / cell",   # [13]
    S21 = "k20 * S20 / cell",   # [14]
    S3 = "k2 * S2 / cell - k3 * S3 / cell",   # [15]
    S4 = "k3 * S3 / cell - k4 * S4 / cell",   # [16]
    S5 = "k4 * S4 / cell - k5 * S5 / cell",   # [17]
    S6 = "k5 * S5 / cell - k6 * S6 / cell",   # [18]
    S7 = "k6 * S6 / cell - k7 * S7 / cell",   # [19]
    S8 = "k7 * S7 / cell - k8 * S8 / cell",   # [20]
    S9 = "k8 * S8 / cell - k9 * S9 / cell"  # [21]
)

y_dmod <- c(
    J1 = "k1 * S1",   # [1]
    J10 = "k10 * S10",   # [2]
    J11 = "k11 * S11",   # [3]
    J12 = "k12 * S12",   # [4]
    J13 = "k13 * S13",   # [5]
    J14 = "k14 * S14",   # [6]
    J15 = "k15 * S15",   # [7]
    J16 = "k16 * S16",   # [8]
    J17 = "k17 * S17",   # [9]
    J18 = "k18 * S18",   # [10]
    J19 = "k19 * S19",   # [11]
    J2 = "k2 * S2",   # [12]
    J20 = "k20 * S20",   # [13]
    J3 = "k3 * S3",   # [14]
    J4 = "k4 * S4",   # [15]
    J5 = "k5 * S5",   # [16]
    J6 = "k6 * S6",   # [17]
    J7 = "k7 * S7",   # [18]
    J8 = "k8 * S8",   # [19]
    J9 = "k9 * S9"  # [20]
)



# -------------------
# odes
# -------------------
f_dxdt <- function(t, x, p){
    # ODE system
    J1 = p[2] * x[1]      # [1] J1
    J10 = p[3] * x[2]      # [2] J10
    J11 = p[4] * x[3]      # [3] J11
    J12 = p[5] * x[4]      # [4] J12
    J13 = p[6] * x[5]      # [5] J13
    J14 = p[7] * x[6]      # [6] J14
    J15 = p[8] * x[7]      # [7] J15
    J16 = p[9] * x[8]      # [8] J16
    J17 = p[10] * x[9]      # [9] J17
    J18 = p[11] * x[10]      # [10] J18
    J19 = p[12] * x[11]      # [11] J19
    J2 = p[13] * x[12]      # [12] J2
    J20 = p[14] * x[13]      # [13] J20
    J3 = p[15] * x[15]      # [14] J3
    J4 = p[16] * x[16]      # [15] J4
    J5 = p[17] * x[17]      # [16] J5
    J6 = p[18] * x[18]      # [17] J6
    J7 = p[19] * x[19]      # [18] J7
    J8 = p[20] * x[20]      # [19] J8
    J9 = p[21] * x[21]      # [20] J9

    # ode
    list(c(
        dS1 = -J1 / p[1],
        dS10 = J9 / p[1] - J10 / p[1],
        dS11 = J10 / p[1] - J11 / p[1],
        dS12 = J11 / p[1] - J12 / p[1],
        dS13 = J12 / p[1] - J13 / p[1],
        dS14 = J13 / p[1] - J14 / p[1],
        dS15 = J14 / p[1] - J15 / p[1],
        dS16 = J15 / p[1] - J16 / p[1],
        dS17 = J16 / p[1] - J17 / p[1],
        dS18 = J17 / p[1] - J18 / p[1],
        dS19 = J18 / p[1] - J19 / p[1],
        dS2 = J1 / p[1] - J2 / p[1],
        dS20 = J19 / p[1] - J20 / p[1],
        dS21 = J20 / p[1],
        dS3 = J2 / p[1] - J3 / p[1],
        dS4 = J3 / p[1] - J4 / p[1],
        dS5 = J4 / p[1] - J5 / p[1],
        dS6 = J5 / p[1] - J6 / p[1],
        dS7 = J6 / p[1] - J7 / p[1],
        dS8 = J7 / p[1] - J8 / p[1],
        dS9 = J8 / p[1] - J9 / p[1]
    ))
}

f_y <- function(times, x, p){
    # Calculate y

    J1 = p[2] * x[1]  # [1] J1
    J10 = p[3] * x[2]  # [2] J10
    J11 = p[4] * x[3]  # [3] J11
    J12 = p[5] * x[4]  # [4] J12
    J13 = p[6] * x[5]  # [5] J13
    J14 = p[7] * x[6]  # [6] J14
    J15 = p[8] * x[7]  # [7] J15
    J16 = p[9] * x[8]  # [8] J16
    J17 = p[10] * x[9]  # [9] J17
    J18 = p[11] * x[10]  # [10] J18
    J19 = p[12] * x[11]  # [11] J19
    J2 = p[13] * x[12]  # [12] J2
    J20 = p[14] * x[13]  # [13] J20
    J3 = p[15] * x[15]  # [14] J3
    J4 = p[16] * x[16]  # [15] J4
    J5 = p[17] * x[17]  # [16] J5
    J6 = p[18] * x[18]  # [17] J6
    J7 = p[19] * x[19]  # [18] J7
    J8 = p[20] * x[20]  # [19] J8
    J9 = p[21] * x[21]  # [20] J9

    # --------------------------------------
    c(J1, J10, J11, J12, J13, J14, J15, J16, J17, J18, J19, J2, J20, J3, J4, J5, J6, J7, J8, J9)
}


f_z <- function(times, X, p){
    # calculate z
    shape <- dim(X)
    Nt <- shape[1]
    Nx <- shape[2] - 1
    Ny = length(yids)
    Nz = 1 + Nx + Ny
    Z = matrix(, nrow=Nt, ncol=Nz)
    Z[,1] = times
    for (kx in seq(Nx)){
        Z[,(1+kx)] = X[,1+kx]
    }
    for (kt in seq(Nt)){
        y = f_y(t=times[kt], x=X[kt, 2:(Nx+1)], p=p)
        Z[kt, (2+Nx):Nz] = y
    }
    colnames(Z) <- c ("time", xids, yids)
    Z
}